#include<stdio.h>
#include "avidetect.h"
#include "mystring.h"
#include "io.h"
#include "avi.h"
#include "yuv.h"

int return_data_stream_start(){

}

int is_AVI_in_header(char *data){
  char data2[]="AVI";
  int tmp,returnvalue;
  returnvalue=1;
  for(tmp=0;tmp<3;tmp++){
    if(data[8+tmp]!=data2[tmp]){
      printf("Doesn't have proper avi header %c %c \n",data[9+tmp],data2[tmp]);
      returnvalue=0;
    }
  }
  return returnvalue;
}

int is_hdrl_in_header(char *data){
  char data2[]="LIST";
  char data3[]="hdrl";
  int tmp,returnvalue;
  returnvalue=1;
  for(tmp=0;tmp<4;tmp++){
    if(data2[tmp]!=data[tmp]){
      printf("Doesn't have proper avi header %c %c \n",data[9+tmp],data2[tmp]);
      returnvalue=0;
    }
    if(data3[tmp]!=data[tmp+8]){
      printf("Doesn't have proper avi header %c %c \n",data[9+tmp],data2[tmp]);
      returnvalue=0;
    }
  }
}

int is_RIFF_header(FILE *testfile,struct avi_filetype *AVI){
  /* Just checks for presence of RIFF and AVI in first 12 bytes*/
  char Buffer[5];
  char data[256];
  
 int i;
  for(i=0;i<4;i++){
    Buffer[i]=getc(testfile);
  }
  Buffer[4]='\0';
  rewind(testfile);

  if(!stringtest("RIFF",Buffer)){
    printf("Buffer is %s and we wanted RIFF\n",Buffer);
    AVI->is_riff=1;
  } else {
    printf("Buffer is %s and we wanted RIFF\n",Buffer);
    AVI->is_riff=0;
  }
  if(is_YUV_header(testfile)){
    printf("It is a YUV file... see documentation\n");
    return 0;
  }
  rewind(testfile);
  
    /* Read the bloody avi... */  
  for(i=0; i<12; i++){
    data[i]=getc(testfile);
  }
  data[12]='\0';
  if(is_AVI_in_header(data)){
    AVI->has_avi_hdr=1;
  }

  for(i=0;i<12;i++){
    data[i]=getc(testfile);
  }
  AVI->has_hdrl=is_hdrl_in_header(data);

  return AVI->is_riff;
}


int get_main_avi_header(FILE *testfile,struct avi_filetype *AVI){
  /* Fill in the avi main header. Yes, I know; if we could do this
     we would have already done so. Still, nil panic & desperandum
     wossname */
  /* First, grab the 'avih' that denotes the beginning of this section, 
     of which the last character (h) is on byte 28 */

  char data[256];
  char data2[]="avih";
  unsigned long int test,test2;
  unsigned int c,c2;
  int count;
  for(count=0; count<4;count++){
    data[count]=getc(testfile);
    if(data[count]!=data2[count]){
      printf("get_main_avi_header: avih not in expected place\n");
    }
  }
 
  /* Oh great. Now we're on the main header for real. First value is
   an unsigned long 'MicroSec per frame' */
 
  //printf("Size of unsigned long int is %d bytes\n\n", sizeof(unsigned long int));

 /* A Windows dword is 4 bytes too - this is what the avi format expects. 
    I hope*/
 
  test=get32(testfile); 
  /* Bugger all idea what this one is */

  AVI->microsec_per_frame=get32(testfile); 
  /* This one is the microseconds per frame */

  AVI->max_bytes_per_second=get32(testfile); 
  /*max bytes per sec. Apparently 0 is normal? */

  test=get32(testfile); 
  /* Reserved value 1 */

  AVI->flags=get32(testfile); 
  /* Flags */

  AVI->total_frames=get32(testfile); /* Total number of frames*/

  AVI->initial_frames=get32(testfile); /* Initial frames. Zero. Dunno */

  AVI->streams=get32(testfile); /* Streams */

  test=get32(testfile); /* SuggestedBufferSize. Err. */

  AVI->width=get32(testfile); /* Width */

  AVI->height=get32(testfile); /* height */

  test=get32(testfile); /* Scale? */
  test=get32(testfile); /* Rate */
  test=get32(testfile); /* Start */
  test=get32(testfile); /* Length */
  //printf("Length %i\n",test);
  /* Oops, I can't count. These two don't exist :-) */
  //test=get32(testfile); /* Dunno */
  //test=get32(testfile); /* Dunno */
  
  printf("AVI header reports: %i microsec per frame at %i max bps \n",AVI->microsec_per_frame,AVI->max_bytes_per_second);
  printf("AVI header reports: %ix%i@ %i frames, %i initial, %i streams, flags[%i]\n",AVI->width,AVI->height,AVI->total_frames,AVI->initial_frames,AVI->streams,AVI->flags);

  /* Our work is done! Let's get back to the main thing */
  return 1;
}

int get_stream_header(FILE *testfile,struct avi_filetype *AVI){
  
  char data[256];
  char data2[]="LIST";
  char data3[]="JUNK";
  unsigned long int test,test2;
  unsigned int c,c2;
  int count;
  //fflush(testfile);
  for(count=0; count<4;count++){
    data[count]=getc(testfile);
  } 
  data[4]='\0';
  printf("%s was what we just got...",data);

  for(count=0; count<4; count++){
    data[count]=getc(testfile);
    //    printf("%c\n",data[count]);
  }
  /* Grabs strl */
  for(count=0; count<4; count++){
    data[count]=getc(testfile);
    // printf("%c\n",data[count]);
  }
  /* Grabs strh */
    for(count=0; count<4; count++){
    data[count]=getc(testfile);
    // printf("%c\n",data[count]);
  }

  for(count=0;count<14;count++){
    get32(testfile);
  }
  //printf("Finished with 32 bit chars?...\n");
  /* Lose the strf( - that's the format */
  for(count=0; count<20; count++){
  data[count]=getc(testfile);
  //printf("%c\n",data[count]);
  }
  /* All about stream 2 format */
  /* This chunk is not a fixed size, it is dependant on the codec you're using. */

  /* Therefore let us currently skip through it until we find 'JUNK' */
  while(1){
    /* Wander through it looking for the word 'Junk' */
    data[0]=getc(testfile);
    if(data[0]=='J'){
      if(getc(testfile)=='U'){
	if(getc(testfile)=='N'){
	  if(getc(testfile)=='K'){
	    break;
	  }
	}
      }
    }
  }
  

  printf("Position in file: %i\n",ftell(testfile));
  /* Now we have got to the end of the line 'JUNK'. 
   We now need to get through the 'strd' optional codec data
  (DOES THIS PARSING NEVER END?!) */

  while(1){
    /* Wander through it looking for the word 'Junk' */
    data[0]=getc(testfile);
    
    if(data[0]=='L'){
      if(getc(testfile)=='I'){
	if(getc(testfile)=='S'){
	  if(getc(testfile)=='T'){
	    ungetc('T',testfile);
	    ungetc('S',testfile);
	    ungetc('I',testfile);
	    ungetc('L',testfile);
	    break;
	  }
	}
      }
    }

  } /* End of while loop*/
  return 1;
}

int parse_index_values(FILE *testfile,struct avi_filetype *AVI){
  /* The optional index chunk contains successions of AVIINDEXENTRY structures, one for each rec and stream data subchunk in the movie chunk. The AVINDEXENTRY structures identify each data chunk and its location in the file */
  /* But, but... YUVs don't have subchunks?...*/
}





