/** 
	avi to raw conversion software by Em Tonkin, csmelt@{SPAMMEANDDIE]bath.ac.uk, also known as admin@typodemon./dontbothertryingit.spammer\.com

	Why?

	Because! (In the cause of academic justice...) - YUV 4:2:2 != YUV 4:2:0. OK? OKKKK? I'm a HCI student and even I know that... 

	May 2002 

	UPDATE, 7th May: It works; C rocks :-)
*/ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct yuv_format {
  int width; /* Width of YUV image */
  int height; /* Height of YUV image */
  int frames; /* Number of frames in the thing */
  int fps; /* number of frames per second in theory */
  int headerlength; /* How many bytes in the header */
  long int filesize; /* Size of the file */
};


int get_rgb_frames(struct yuv_format *formats,FILE *input_file,int **rframe, int **gframe, int **bframe, int framenumber){
  int framesize,i,j,tmpint;
  framesize=formats->width*formats->height;

  /* Fill in the rgb frames! */

  for(j=formats->height-1;j>0;j--){
    for(i=0; i<formats->width;i++){
      
      if(feof(input_file)) return 1;
      bframe[j][i]=getc(input_file);
      gframe[j][i]=getc(input_file);
      rframe[j][i]=getc(input_file);
    }
  }
  
  
}



write_yuv_frame(struct yuv_format *formats,FILE *output_file,int **yframe1,int **uframe1,int **vframe1){
  /* Damn, I've forgotten how the YUV thing works... */
  int frames,tmpint,width,height,i,j,k;
  printf("Copying y frame\n");

  /* Write a line*/
  /* This one more or less worked... but upsidedown*/

  for( j =0; j<formats->height;j++ ) {
    for( i = 0; i < formats->width; i++ ) {
      fputc(  yframe1[j][i], output_file );
    }
  }

   
  
  // subsample u
  /* Guessing:

   1 1 1 1 1 1 1 
   1 1 1 1 1 1 1 
   1 1 1 1 1 1 1
   1 1 1 1 1 1 1 

  remove every other row...
  1 1 1 1 1 1 1 

  1 1 1 1 1 1 1

  then remove every other wossname, thingy, column (yawn)
  */

  printf("Copying u frame\n");  
 
  //This one worked...


  for( j = 0; j<formats->height; j++ ) {
    for( i = 0; i < formats->width; i+=2 ) {
      fputc(  uframe1[j][i], output_file );
    }
  }

  
  // subsample v
  /* Still guessing... :-( */
  printf("Copying v frame\n");


  /* This one worked... */
  for( j =0; j<formats->height; j++ ) {
    for( i = 0; i < formats->width; i+=2 ) {
      fputc(  vframe1[j][i], output_file );
    }
  }

}


int fwrite_header( FILE *output_file, struct yuv_format *formats)
{
  fprintf( output_file, "%s\n", "P5" );
  fprintf( output_file, "%d %d\n", formats->width, formats->height );
  fprintf( output_file, "%d\n", 255 );
  return( 0 );
}

/* Function to save a array as a pgm file (adapted from Dr. Evans Code) */
void savefile( FILE *output_file, int **yframe, struct yuv_format *formats)  {
  int i,j;
  printf("Formats.height is %i and width is %i\n",formats->height,formats->width);
  fwrite_header(output_file, formats);
  for( i = 0; i < formats->height; i++ ) {
    for( j = 0; j < formats->width; j++ ) {
      fputc(  yframe[i][j], output_file );
    }
  }
  
}



void write_yuv_header(FILE *output_file, struct yuv_format *formats){
  /* This much of it appears, and note I say APPEARS, to be working */
  printf("Writing header for YUV 4.2.0 %i by %i image... \n",formats->width,formats->height);
  fprintf( output_file, "YUV 4:2:2");
  putc('\0',output_file);
  fprintf(output_file,"%i",formats->width);
  putc('\0',output_file);
  putc('\n',output_file);
  fprintf(output_file,"%i",formats->height);
  putc('\0',output_file);
  putc('\n',output_file);
  fprintf(output_file,"30");
  putc('\0',output_file);

}



/* 
   Intel's opinion on the subject of RGB to YUV conversion:

http://cedar.intel.com/cgi-bin/ids.dll/content/content.jsp?cntKey=Legacy::irtm_AP548_9996&cntType=IDS_EDITORIAL&catCode=0#RGB%20To%20YUV%20Color%20Conversion%20Equations

Two sets of equations for RGB to YUV color conversion are given in Example 1. The first set is a floating-point version. The second set describes calculations made in the MMX code presented here. MMX registers execute integer operations. Coefficients in the second set are equal to the product of 32768, which equals 215, and the coefficients in the first set of equations rounded to the nearest integer and divided by 32768. The code adds 128 to the results for U and V to assure they are positive.

Example 1. RGB to YUV Color Conversion Equations

Y = 0.299R 0.587G + 0.114B Conventional floating-point equations
U =-0.146 R - 0.288 G + 0.434 B			
V = 0.617 R - 0.517 G - 0.100 G

Y = [(9798 R + 19235G + 3736 B) / 32768] Equations used by code.
U = [(-4784 R - 9437 G + 14221 B) / 32768] + 128	
V = [(20218R - 16941G - 3277 B) / 32768] + 128


*/


convert_y(struct yuv_format *formats, int **rframe, int **gframe, int **bframe, int **yframe){
  int i,j,tmp;

  for( j = 0; j < formats->height; j++ ) {
    for( i = 0; i < formats->width; i++ ) {

      /* All right then, let's try the INTEL version */

      yframe[j][i]= ((9798 *rframe[j][i] + 19235*gframe[j][i] + 3736 *bframe[j][i]) / 32768);

      /* 

	 Two possible code versions what don't QUITE work. The top one, however, works better than No. 2.

	 //yframe[j][i]=(0.299*rframe[j][i])+(0.587*gframe[j][i])+(0.114*bframe[j][i])+16;
	 // yframe[j][i]=(0.257*rframe[j][i])+(0.504*gframe[j][i])+(0.098*bframe[j][i])+16;
      */

      if (yframe[j][i] > 255) 
	yframe[j][i]= 255;
      if(yframe[j][i]<0){
	yframe[j][i]=0;
      }
    }
  }
  
}


convert_u(struct yuv_format *formats, int **rframe, int **gframe, int **bframe, int **yframe,int **yframe2){
  int i,j,tmp;

    for( j = 0; j < formats->height; j++ ) {
      for( i = 0; i < formats->width; i++ ) {

	/* INTEL version */
	yframe[j][i] = ((-4784 *rframe[j][i] - 9437 * gframe[j][i] + 14221 *bframe[j][i]) / 32768) + 128;	
	
	
	
	/* The top of these two works better than the bottom one...*/
	//yframe[j][i]=0.565*(bframe[j][i]-yframe2[j][i])+128;
	//yframe[j][i]=(0.439*rframe[j][i])+(0.368*gframe[j][i])+(0.071*bframe[j][i])+16;
	
	if (yframe[j][i] > 255) 
	  yframe[j][i]= 255;
	if(yframe[j][i]<0){
	  yframe[j][i]=0;
	}
	
	
      }
    }
    
}

convert_v(struct yuv_format *formats, int **rframe, int **gframe, int **bframe, int **yframe,int **yframe2){
  int i,j,tmp;
  
  for( j = 0; j < formats->height; j++ ) {
    for( i = 0; i < formats->width; i++ ) {

      /* INTEL version*/

      yframe[j][i] = ((20218*rframe[j][i] - 16941* gframe[j][i] - 3277 * bframe[j][i]) / 32768) + 128;

      /* Two versions that don't work, quite. You know the routine. */
      //yframe[j][i]=0.713*(rframe[j][i]-yframe2[j][i])+128;
      //yframe[j][i]=(0.148*rframe[j][i])+(0.291*gframe[j][i])+(0.439*bframe[j][i])+128;


      if (yframe[j][i] > 255) 
	yframe[j][i]= 255;
      if(yframe[j][i]<0){
	yframe[j][i]=0;
      }
      
    }
  }
  
}




int stringtest(char* needle,char* haystack){
  int returnvalue,i;

  returnvalue=0;

  /* if returnvalue is 0 when it returns, we found it...*/

  /* Checks whether a string starts with another string*/
  /* So this has the behaviour of ~/^needle/ */
  
  //  printf("Looking for %s in %s",needle,haystack);
  for(i=0;i<strlen(needle);i++){
    if(needle[i]!=haystack[i]){
      returnvalue=1;
      break;
    }
  }
  return(returnvalue);
  
  
  
  
}

int strcpyint(char *mystring,int myint){
  sprintf(mystring,"%i.pgm",myint);
}


int main(int argc, char* argv[])
{
  char Buffer[256];
  char Buffer2[256];
  char a;
  double frames2;
  int frames,end,j,p,k,width,height,fps,headerlen;
  unsigned int length,i;
  FILE *input_file;
  FILE *output_file;
  FILE *output_file2;
  /* need pointer to Buffer for getline */
  int *lineptr;
  int **yframe1;
  int **uframe1;
  int **vframe1;
  int **rframe1;
  int **gframe1;
  int **bframe1;
  struct yuv_format movie1format;
  int tmpint;
  tmpint=0;
  //*lineptr=Buffer[0];


   movie1format.height=486;
  // movie1format.height=487;
  movie1format.width=720;
  //open input for reading
  if((input_file=fopen(argv[1],"r"))==NULL){
    
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    return -1;
  }
  
  //open output
  if((output_file=fopen(argv[2],"wb"))==NULL){
    fprintf(stderr,"Cannot open %s\n",argv[2]);
    return -1;
  }
  
  // This ought to be faster.. apparently not though
  i=ftell(input_file);
  fseek(input_file,0,SEEK_END);
  j=ftell(input_file);
  rewind(input_file);
  tmpint=j-i;
  frames2=movie1format.width*movie1format.height;
  printf("\nvideo stream length=%i, frametest %f\n",tmpint,frames2);
  frames2=tmpint/(3*frames2);
  printf("\n\nWe've found %f frames, width %i, height %i and %i bytes...\n",frames2,movie1format.width,movie1format.height,tmpint);
  printf("\nWe'll round that frames value down...\n");
  /* Yes, I know there are frames going missing. Oh. Dear. Sue me.*/
  movie1format.frames=(int)(frames2);
  printf("after that we have %i frames\n",(int)frames2);

  for(i=0;i<2068;i++){
    j=getc(input_file);
    printf("%i(%c)",j,j);
  }
  printf("Malloc... if it fails here, you got no memory :-) \n");
  yframe1 = ( int ** )malloc( sizeof( int * )*( movie1format.height ) );
  uframe1 = ( int ** )malloc( sizeof( int * )*( movie1format.height ) );
  vframe1 = ( int ** )malloc( sizeof( int * )*( movie1format.height ) );
  rframe1 = ( int ** )malloc( sizeof( int * )*( movie1format.height ) );
  gframe1 = ( int ** )malloc( sizeof( int * )*( movie1format.height ) );
  bframe1 = ( int ** )malloc( sizeof( int * )*( movie1format.height ) );


  for( i = 0; i < movie1format.width; i++ ) {
    yframe1[i] = malloc( movie1format.width*sizeof( int ) );
    uframe1[i] = malloc( movie1format.width*sizeof( int ) );
    vframe1[i] = malloc( movie1format.width*sizeof( int ) );
    rframe1[i] = malloc( movie1format.width*sizeof( int ) );
    gframe1[i] = malloc( movie1format.width*sizeof( int ) );
    bframe1[i] = malloc( movie1format.width*sizeof( int ) );
          
  }
  printf("\n");
  /* How do I find the end of this goddamn file??? */
  
  fseek(input_file,0,i);
  //get_y_frame(&movie1format,input_file,yframe1,1);
  //get_y_frame(&movie1format,input_file,yframe1,1);
  //get_y_frame(&movie1format,input_file,yframe1,1);
  
  
  //savefile(output_file,yframe1, &movie1format);


  write_yuv_header(output_file,&movie1format);
  printf("Finished writing header\n");

  /* Currently assuming that input is raw as that is
     the problem right now */

  /* NB The input is actually BGR... don't ask*/
  for(i=0;i<movie1format.frames;i++){
    /* Get an B */
    /* Get a G */
    /* Get a R  */

    printf("Getting the RGB frames\n");
    get_rgb_frames(&movie1format,input_file,rframe1, gframe1, bframe1,1);
    printf("Got the RGB frames\n");
    /* We're going to temporarily do 4:4:4 YUV */
    /* We can cut it down when we save each bit...
       I just have too big a headache as it is */
    
    convert_y(&movie1format,rframe1,gframe1,bframe1,yframe1);
    convert_u(&movie1format,rframe1,gframe1,bframe1,uframe1,yframe1);
    convert_v(&movie1format,rframe1,gframe1,bframe1,vframe1,yframe1);
    printf("Finished conversion!\n");
    write_yuv_frame(&movie1format,output_file,yframe1,uframe1,vframe1);

    //getc(input_file);
    //getc(input_file);
    // getc(input_file);
    //getc(input_file);
    //getc(input_file);
    //getc(input_file);
    //getc(input_file);
    for(j=0;j<(8);j++){
      getc(input_file);

    }
    /*    for(j=0;j<720*2;j++){
      ungetc(0,input_file);
      }*/


    //open output

     
    /*    printf("Setting filename...\n");
       //strcpy(Buffer,"");
       strcpyint(Buffer,i);
       //strncat(Buffer,".pgm",4);
       printf("Static filename %s\n",Buffer);
    */
    /*    
       if((output_file2=fopen("Buffer.pgm","wb"))==NULL){
       fprintf(stderr,"Cannot open %s\n",argv[2]);
       return -1;
       }  
       savefile(output_file2,uframe1, &movie1format);
       fclose(output_file2);
    */
    
  } /* End of  loop over all frames */


  for( i = 0; i < movie1format.width; i++ ) {
    free(yframe1[i]);
    free(uframe1[i]);
    free(vframe1[i]);
    free(rframe1[i]);
    free(gframe1[i]);
    free(bframe1[i]);
    
  }
  
  free(yframe1);
  free(uframe1);
  free(vframe1);
  free(rframe1);
  free(gframe1);
  free(bframe1);

  fclose(input_file);
  fclose(output_file);
  
  return 0;
}






