// Ex-Windows console app designed to convert YUVs
// Really not a big deal.
// *shrug*
// Original code by a helpful PhD bloke at Bath Uni
// Linux (or, as most of us call it, ANSI C, version) by
// Em Tonkin (admin@typodemon.com)
/** 
	Why?

	Because!
 
	May 2002 
*/ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char* argv[])
{
        char Buffer[256];
        char Buffer2[256];
        char a;
        int frames,end,j,p,k,width,height,fps,headerlen;
        unsigned int length,i;
        FILE *input_file;
        FILE *output_file;
	/* need pointer to Buffer for getline */
	int *lineptr;
	int tmpint;
	tmpint=0;
	//*lineptr=Buffer[0];

	// Because there are some fubared YUVs out there with less \ns
	// than they should have...

	headerlen=23;	
	
	if (argc != 3) {
	
		printf("\nSyntax is:");
		printf("\n\tConvert\n\t\tinput filename");		
		printf("\n\t\toutput_name\n");		
				
		return -1;
	}

	

	//all we want is to put a header onto a raw yuv420 sequence.
	// and to turn the stream into 420 if it's 422


	//open input for reading
	if((input_file=fopen(argv[1],"r"))==NULL){

		fprintf(stderr,"Cannot open %s\n",argv[1]);
		return -1;
	}

	//open output
	if((output_file=fopen(argv[2],"w"))==NULL){
		fprintf(stderr,"Cannot open %s\n",argv[2]);
		return -1;
	}

	// If this is indeed a YUV file with a little header on it,
	// then this will get the first bit from it -
	// YUV 4:2:2\0	
	while((a = getc(input_file)) !='\0') {
			printf("%c",a);
			if(feof(input_file)) break;
		}


	// If we do this again, you get... width (720), for example
	// On the Bath headers this is a three byte bit followed by another \0 

	fscanf(input_file,"%i",&width);
	printf("\nWidth is %i",width);
	
	// NB. The width is followed by a carriage return (\n)
	// This is then followed by the height, eg three byte followed by \0 
	// Warning: Getc considered bloody stupid. However, also 
	// convenient and this is a security unimportant userspace 
	// app... so :-) 
	getc(input_file);	
	tmpint=getc(input_file);
	if(tmpint!='\n') { 
		ungetc(tmpint,input_file);
		headerlen--;
		printf("\nMissing a return!\n");
	}
	fscanf(input_file,"%i",&height);
	printf("Height is %i\n", height);

	// Another carriage return then happens here:\n, followed by 
	// a value frames per second (eg, 30) which is followed by \0
	getc(input_file);
	tmpint=getc(input_file);
	if(tmpint!='\n') {
		printf("Missing a return \n");
		ungetc(tmpint,input_file);
		headerlen--;
	}

	fscanf(input_file,"%i",&fps);
	printf("Frames per second : %i",fps);
	getc(input_file);
	
	// Yay - that last getc() took in the \0
	// we are now pointing to the start of the movie

	// Let's write the headers;
	fputs("YUV 4:2:0",output_file);
	putc('\0',output_file);

	// Write width:
	fprintf(output_file,"%i",width);
	putc('\0',output_file);
	putc('\n',output_file);

	// Write length:
	fprintf(output_file,"%i",height);
	putc('\0',output_file);
	putc('\n',output_file);

	// Write fps:
	fprintf(output_file,"%i",fps);
	putc('\0',output_file);

	// We then proceed with the actual movie :-)

	//  YUV 4.2.2 source; thus the U and the V together equal the Y
	// and the total size of each frame is 2x the Y size

	length = width*height*2;

	// This ought to be faster.. apparently not though
	i=ftell(input_file);
	fseek(input_file,0,SEEK_END);
	j=ftell(input_file);
	rewind(input_file);
	tmpint=j-i;
	printf("\nvideo stream length=%i\n",tmpint);
	frames=(int)tmpint/length;
	printf("\nwhich makes %i frames, not inc leftovers\n",frames);	

	// Go back to the end of the headers;
	printf("\nHeader length is %i \n",headerlen);
	for(tmpint=0; tmpint<headerlen; tmpint++){
		i=getc(input_file);
		// Paint me too lazy to compile ncurses into this thing :-/
		// True, sometime I should do better than this
		printf("%d ",i);
	}

	//now copy the rest of the file
	for(tmpint=0; tmpint<frames; tmpint++){
		printf("Processing frame %i\n",tmpint+1);
		// Loop through frames
		// copy y frame
		for(j=0;j<width*height;j++)
		{
			a = getc(input_file);
			putc(a,output_file);

		}
		// subsample u
		for(j=0; j<height; j+=2)
		{
			for(k=0;k<width/2;k++){
				a = getc(input_file);
				putc(a,output_file);
			}
			for(k=0;k<width/2;k++){
				getc(input_file);			
			}

		}
		

		// subsample v
                // subsample u
                for(j=0; j<height; j+=2)
                {
                        for(k=0;k<width/2;k++){
                                a = getc(input_file);
                                putc(a,output_file);
                        }
                        for(k=0;k<width/2;k++){
                                getc(input_file);                       
                        }

                }

		
	}

	fclose(input_file);
	fclose(output_file);

	return 0;
}

