/* 

There's a way of testing the integrity of a video before and after conversion
that goes like this:

get a YUV frame from the movie before compression,
and one from after

check out the difference of each pixel, and make a drawing from it:
if there's no difference, the whole image is, say, black
if there's a small difference on a pixel, that pixel is set to a lighter 
shade.
if there's a big difference, that pixel is set to a very light shade.

Maybe I should make the difference between the pixel shades something that you can set - we could have a key '5 shades of grey is one unit different'

You only check the Y, not the U or V part of it, so if it's 4.2.2 or whatever makes no difference at all.

It'd be good if you could pick frames from different places in the movie, it's just a question of fast-forwarding a set number of bytes.

*/
#include <stdio.h>
#include "mystring.h"

long int get_filesize(FILE *input_file){
  long int filepos,endpos;
  filepos=ftell(input_file);
  fseek(input_file,0,SEEK_END);
  endpos=ftell(input_file);
  fseek(input_file,0,filepos);
  return endpos;
}

int is_YUV_header(FILE *input_file){
  /* Hope long int is long enough :-(*/
  long int filepos,endpos;
  int tmp;
  char Buffer[4];
  /* Get current position in file */
  filepos=ftell(input_file);

  /* Go to beginning (have to, to read headers..) */
  fseek(input_file,0,0);
  for(tmp=0;tmp<3;tmp++){
    Buffer[tmp]=getc(input_file);
  }
  Buffer[3]='\0';
   if(!stringtest("YUV",Buffer)){
    printf("Header says %s\n",Buffer);
    return 1;
  } else {
    printf("Header says %s\n",Buffer);
    return 0;
  }
  return 1;
}
